
// DropboxAppDlg.cpp : implementation file
//
#pragma once
#include "stdafx.h"
#include "resource.h"

#include "DropboxAppDlg.h"
#include "afxdialogex.h"



using namespace concurrency;
using namespace web::http;
using namespace web::http::client;
using namespace Authentication;
using namespace pplx;
using namespace concurrency::streams;
using namespace web::storage;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CDropboxAppDlg dialog

std::shared_ptr<AppCredentials> appcreds = std::make_shared<AppCredentials>();

CDropboxAppDlg::CDropboxAppDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CDropboxAppDlg::IDD, pParent)
	, m_consumerKey(_T(""))
	, m_consumerSecret(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);	
}

void CDropboxAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_CKEY_EDIT, m_consumerKey);
	DDX_Text(pDX, IDC_CSECRET_EDIT, m_consumerSecret);
}

BEGIN_MESSAGE_MAP(CDropboxAppDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()	
	ON_BN_CLICKED(IDC_LOGIN_BUTTON, &CDropboxAppDlg::OnBnClickedLoginButton)
	ON_BN_CLICKED(IDC_AUTHORIZE_BUTTON, &CDropboxAppDlg::OnBnClickedAuthorizeButton)
	ON_BN_CLICKED(IDC_ACQUIRETOKEN_BUTTON, &CDropboxAppDlg::OnBnClickedAcquiretokenButton)
	ON_BN_CLICKED(IDC_UPLOADFILE_BUTTON, &CDropboxAppDlg::OnBnClickedUploadfileButton)
END_MESSAGE_MAP()


// CDropboxAppDlg message handlers

BOOL CDropboxAppDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDropboxAppDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDropboxAppDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDropboxAppDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

task<void> CDropboxAppDlg::OAuthLoginAsync(std::shared_ptr<AppCredentials>& creds)
{
    uri url(DropBoxRequestTokenURI);
    std::shared_ptr<OAuth> oAuthObj = std::make_shared<OAuth>();		
    auto signatureParams = 
		oAuthObj->CreateOAuthSignedParameters(url.to_string(),
		L"GET",
		NULL,
		consumerKey,
		consumerSecret
		);
		
    std::wstring sb = oAuthObj->OAuthBuildSignedHeaders(url);	
    http_client client(sb);	
	
    // Make the request and asynchronously process the response. 		
    return client.request(methods::GET)
           .then([&creds](http_response response)
    {			
        if(response.status_code() != status_codes::OK)
        {		    
            // Handle error cases... 
            return pplx::task_from_result();
        }
        
        // Perform actions here reading from the response stream... 
        // In this example, we parse the response body and 
		// extract the token and token secret.
        concurrency::streams::istream bodyStream = response.body();
        container_buffer<std::string> inStringBuffer;
        return bodyStream.read_to_end(inStringBuffer)
               .then([inStringBuffer, &creds](pplx::task<size_t> previousTask)
        {			
            const std::string &text = inStringBuffer.collection();

            // convert the response text to a wide-character string and then extract the tokens.
            std::wstring_convert<std::codecvt_utf8_utf16<wchar_t>, wchar_t> utf16conv;
            std::wostringstream ss;
            std::vector<std::wstring> parts;
            ss << utf16conv.from_bytes(text.c_str()) << std::endl;
            Split(ss.str(), parts, '&', false);
            unsigned pos = parts[1].find('=');
            std::wstring token = parts[1].substr(pos + 1, 16);
            
            pos = parts[0].find('=');
            std::wstring tokenSecret = parts[0].substr(pos + 1);
            creds->SetToken(token);
            creds->SetTokenSecret(tokenSecret);
        });
    });
}

void CDropboxAppDlg::AuthorizeDropBoxAccess(std::shared_ptr<AppCredentials>& creds)
{	
    std::wstring url = DropBoxAuthorizeURI;
	
    url += L"?oauth_token=";
    url += utility::conversions::to_string_t(creds->Token());
    	
    //start an instance of IE to validate the authorize process
    PROCESS_INFORMATION procInfo;
    IELAUNCHURLINFO launchInfo;
    launchInfo.cbSize = sizeof(IELAUNCHURLINFO);
    launchInfo.dwCreationFlags = NULL;

    HRESULT hr = IELaunchURL(&url[0], &procInfo, &launchInfo);
    if (SUCCEEDED(hr))
    {
        WaitForInputIdle(procInfo.hProcess, 2000);
        CloseHandle(procInfo.hProcess);
        CloseHandle(procInfo.hThread);
    }
}

task<void> CDropboxAppDlg::OAuthAcquireTokenAsync(std::shared_ptr<AppCredentials>& creds)
{
    uri url(DropBoxAccessTokenURI);

    std::shared_ptr<OAuth> oAuthObj = std::make_shared<OAuth>();	
	
    auto signatureParams = 
		oAuthObj->CreateOAuthSignedParameters(url.to_string(), 
		L"GET", 
		NULL,
		consumerKey,
		consumerSecret,
		creds->Token(),
		creds->TokenSecret()
		);
	
	
    std::wstring sb = oAuthObj->OAuthBuildSignedHeaders(url);
	
    http_client client(sb);	
	
    //// Make the request and asynchronously process the response. 		
    return client.request(methods::GET).then([&creds](http_response response)
    {				
        if(response.status_code() != status_codes::OK)
        {
		    auto stream = response.body();		
		    container_buffer<std::string> inStringBuffer;
		    return stream.read_to_end(inStringBuffer).then([inStringBuffer](pplx::task<size_t> previousTask)
		    {
				//previousTask.get();
			    const std::string &text = inStringBuffer.collection();

			    // convert the response text to a wide-character string.
			    std::wstring_convert<std::codecvt_utf8_utf16<wchar_t>, wchar_t> utf16conv;
			    std::wostringstream ss;				
			    ss << utf16conv.from_bytes(text.c_str()) << std::endl;				
			    OutputDebugString(ss.str().data());
		    });
            // Handle error cases... 
            return pplx::task_from_result();
        }


        // Perform actions here reading from the response stream...         
	    concurrency::streams::istream bodyStream = response.body();
        container_buffer<std::string> inStringBuffer;
	    return bodyStream.read_to_end(inStringBuffer).then([inStringBuffer, &creds](pplx::task<size_t> previousTask)
        {
			//previousTask.get();
            const std::string &text = inStringBuffer.collection();

            // convert the response text to a wide-character string.
            std::wstring_convert<std::codecvt_utf8_utf16<wchar_t>, wchar_t> utf16conv;
            std::wostringstream ss;
		    std::vector<std::wstring> parts;
            ss << utf16conv.from_bytes(text.c_str()) << std::endl;
		    Split(ss.str(), parts, '&', false);
		    unsigned pos = parts[1].find('=');
		    std::wstring token = parts[1].substr(pos + 1, 16);

		    pos = parts[0].find('=');
		    std::wstring tokenSecret = parts[0].substr(pos + 1);			
		    creds->SetToken(token);
		    creds->SetTokenSecret(tokenSecret);
        });

    });

}

task<void> CDropboxAppDlg::UploadFileToDropBoxAsync(std::shared_ptr<AppCredentials>& creds)
{
    using concurrency::streams::file_stream;
    using concurrency::streams::basic_istream;

    uri url(DropBoxFileUploadURI);
    std::shared_ptr<OAuth> oAuthObj = std::make_shared<OAuth>();	
	
    auto signatureParams = 
		oAuthObj->CreateOAuthSignedParameters(url.to_string(),
		L"PUT",
		NULL,
		consumerKey,
		consumerSecret,
		creds->Token(),
		creds->TokenSecret()
		);	
    
	std::wstring sb = oAuthObj->OAuthBuildSignedHeaders(url);
    return file_stream<unsigned char>::open_istream(LocalFiletoUpload)
           .then([sb, url](pplx::task<basic_istream<unsigned char>> previousTask)
    {
        try
        {
            auto fileStream = previousTask.get();
            //get the content length, used to set the Content-Length property
            fileStream.seek(0, std::ios::end);
            auto length = static_cast<size_t>(fileStream.tell());
            fileStream.seek(0, 0);

            // Make HTTP request with the file stream as the body.						
            http_request req;			
            http_client client(sb);		
            req.set_body(fileStream, length);				
            req.set_method(methods::PUT);			
            return client.request(req)
                    .then([fileStream](pplx::task<http_response> previousTask)
            {
	            fileStream.close();
	            std::wostringstream ss;
	            try
	            {
		            auto response = previousTask.get();
		            auto body = response.body();		
		            // log response success code
					ss << L"Server returned status code "
						<< response.status_code() << L"."
						<< std::endl;
					OutputDebugString(ss.str().data());
	            }
	            catch (const http_exception& e)
	            {
		            ss << e.what() << std::endl;
					OutputDebugString(ss.str().data());
	            }				
            });            
        }		
        catch (const std::system_error& e)
        {
            // log any errors here
            // Return an empty task. 
			std::wostringstream ss;
			ss << e.what() << std::endl;
			OutputDebugString(ss.str().data());
            return pplx::task_from_result();
        }
    });
}

void CDropboxAppDlg::OnBnClickedLoginButton()
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_LOGIN_BUTTON)->EnableWindow(FALSE);
	GetDlgItem(IDC_ACQUIRETOKEN_BUTTON)->EnableWindow(FALSE);
	GetDlgItem(IDC_AUTHORIZE_BUTTON)->EnableWindow(FALSE);
	GetDlgItem(IDC_UPLOADFILE_BUTTON)->EnableWindow(FALSE);
	
	GetDlgItemText(IDC_CKEY_EDIT, m_consumerKey);
	consumerKey = m_consumerKey;
	GetDlgItemText(IDC_CSECRET_EDIT, m_consumerSecret);
	consumerSecret = m_consumerSecret;

	//null the edit boxes containing the keys
	SetDlgItemText(IDC_CKEY_EDIT, L"");	
	SetDlgItemText(IDC_CSECRET_EDIT, L"");
	//Login now...
	OAuthLoginAsync(appcreds).wait();

	GetDlgItem(IDC_AUTHORIZE_BUTTON)->EnableWindow(TRUE);
	
}


void CDropboxAppDlg::OnBnClickedAuthorizeButton()
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_AUTHORIZE_BUTTON)->EnableWindow(FALSE);	
	AuthorizeDropBoxAccess(appcreds);
	// wait until user authorizes dropbox access via the browser
	Sleep(2500);
	GetDlgItem(IDC_ACQUIRETOKEN_BUTTON)->EnableWindow(TRUE);
}


void CDropboxAppDlg::OnBnClickedAcquiretokenButton()
{
	// TODO: Add your control notification handler code here	
	OAuthAcquireTokenAsync(appcreds).wait();
	GetDlgItem(IDC_ACQUIRETOKEN_BUTTON)->EnableWindow(FALSE);
	GetDlgItem(IDC_UPLOADFILE_BUTTON)->EnableWindow(TRUE);
	
}


void CDropboxAppDlg::OnBnClickedUploadfileButton()
{
	// TODO: Add your control notification handler code here
	
	CFileDialog fileDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY|OFN_FILEMUSTEXIST, L"TXT Files(*.txt)|*.txt||",this);
	// Display the file dialog. When user clicks OK, fileDlg.DoModal()
	// returns IDOK.
	if( fileDlg.DoModal ()==IDOK )
	{
		LocalFiletoUpload = fileDlg.GetPathName();			
	}
	if (!LocalFiletoUpload.empty())
	{
		UploadFileToDropBoxAsync(appcreds).wait();		
		MessageBox(L"File uploaded successfully", L"Dropbox App", MB_ICONINFORMATION);
	}
}
