
// DropboxAppDlg.h : header file
//
#pragma once


// CDropboxAppDlg dialog
class CDropboxAppDlg : public CDialogEx
{
// Construction
public:
	CDropboxAppDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_DROPBOXAPP_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	CString m_consumerKey;
	CString m_consumerSecret;
	afx_msg void OnBnClickedLoginButton();
	
	afx_msg void OnBnClickedAuthorizeButton();
	afx_msg void OnBnClickedAcquiretokenButton();
	afx_msg void OnBnClickedUploadfileButton();

private:
	void AuthorizeDropBoxAccess(std::shared_ptr<web::storage::AppCredentials>& creds);
	pplx::task<void> OAuthAcquireTokenAsync(std::shared_ptr<web::storage::AppCredentials>& creds);
	pplx::task<void> UploadFileToDropBoxAsync(std::shared_ptr<web::storage::AppCredentials>& creds);
	pplx::task<void> OAuthLoginAsync(std::shared_ptr<web::storage::AppCredentials>& creds);
};
