﻿//
// MainPage.xaml.h
// Declaration of the MainPage class.
//

#pragma once
#include "MainPage.g.h"



namespace XamlDropboxApp
{
	/// <summary>
	/// An empty page that can be used on its own or navigated to within a Frame.
	/// </summary>
	public ref class MainPage sealed
	{
	public:
		MainPage();

	protected:
		virtual void OnNavigatedTo(Windows::UI::Xaml::Navigation::NavigationEventArgs^ e) override;
		void SignInBtnClicked(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void UploadFileBtnClicked(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		

	private:
		Windows::Security::Authentication::OnlineId::OnlineIdAuthenticator^ m_authenticator;
		Windows::Storage::StorageFile^ m_fileToUpload;
		std::shared_ptr<web::storage::AppCredentials> m_creds;
		std::wstring m_authurl;
		Windows::UI::Core::CoreDispatcher^ m_dispatcher;

		pplx::task<void> OAuthLoginAsync(std::shared_ptr<web::storage::AppCredentials>& creds);
		pplx::task<void> OAuthAcquireTokenAsync(std::shared_ptr<web::storage::AppCredentials>& creds);
		pplx::task<void> UploadFileToDropBoxAsync(std::shared_ptr<web::storage::AppCredentials>& creds);		
	};
}
